#!/bin/sh
length=${1:-6}
choose() {
  shuf -n 1 --random-source=/dev/urandom
}
random() {
  seq -"$1" "$1" | choose
}
dir=$(mktemp -d || exit 1)
solution=''
for i in $(seq 1 "$length"); do
  rotate=$(random 16)
  font="Nimbus$(echo MonoPS Sans Roman | tr ' ' '\n' | choose)-Regular"
  points=$(
    for x in 25 50 75; do for y in 25 50 75; do
      printf '%s,%s %s %s ' "$x" "$y" "$((x+$(random 6)))" "$((y+$(random 6)))"
    done; done
  )
  letter=$(echo 2345689ABDHMNQRT | grep -o . | choose)
  solution="$solution$letter"
  convert -size 100x100 -gravity center -font "$font" -pointsize 50 label:"$letter" -canny 0x1+10%+30% -distort Shepards "$points" -distort SRT "$rotate" -negate -trim "$dir/$i.png" || exit 1
done
convert "$dir"/*.png -set page '+%[fx:u[t-1]page.x+u[t-1].w-8]+0' -compose multiply -layers merge +repage -gravity center -extent 240x48 -quality 75 "$dir/combined.jpg" || exit 1
cat "$dir/combined.jpg"
printf '%s' "$solution"
rm -r "$dir"
