#!/usr/bin/luajit
local common = require('common')
local gen = require('gen')
local db = require('database')('../Data/board.db')

local list_files = db:prepare_mult([[
  SELECT hash || extension FROM files
    UNION ALL SELECT thumb FROM files WHERE thumb IS NOT NULL
    UNION ALL SELECT thumb_catalog FROM files WHERE thumb_catalog IS NOT NULL
]])

db:transaction(function()
  local orphans = {}
  local file_list = common.exec_read('find ../File/ -type f -ctime +0 -mtime +0 -print0')
  for file in file_list:gmatch('%.%./File/[^%z]+') do
    orphans[file] = true
  end
  for _, file in ipairs(list_files({})) do
    orphans[gen.file_path(file)] = nil
  end
  for file, _ in pairs(orphans) do
    local basename = file:match('[^/]+$')
    if basename then
      os.rename(file, '../Clean/' .. basename)
    end
  end
  return true
end)

os.execute("find ../Clean/ -type f -ctime +7 -mtime +7 -execdir /usr/bin/shred -u -- '{}' '+'")
