#!/bin/sh
# This example script will install the lambdaplusjs board software on a machine running Debian Bookworm.
# You should modify these steps to suit your operating system and needs.
# Not covered but recommended: Setting up firewall rules, setting the time zone used by lighttpd.
# This assumes you have already fetched the source code, which you can do with
#   apt-get update && apt-get install -y tor torsocks git
#   torsocks git clone http://lambdaplusjs35padjaiz4jw2fugdoeutse262phqr72uf634s2wdbqd.onion/Source/
# The script will make the board available at localhost. If you want to run a Tor hidden service, do
#   apt-get update && apt-get install -y tor
#   printf '\nHiddenServiceDir /var/lib/tor/board/\nHiddenServicePort 80 127.0.0.1:80\n' >> /etc/tor/torrc
#   service tor restart
# and you can find the hostname of the site with
#   cat /var/lib/tor/board/hostname
set -ev
source=$(cd -- "$(dirname -- "$0")" && pwd)
apt-get update
apt-get install -y --no-install-recommends ca-certificates cron lighttpd lighttpd-mod-deflate luajit build-essential luarocks libsqlite3-0 libsqlite3-dev sqlite3 libfcgi0ldbl libfcgi-dev libssl3 libssl-dev file imagemagick librsvg2-bin fonts-urw-base35 ffmpeg poppler-utils git libjxl-tools
luarocks install lsqlite3
luarocks install fcgi
luarocks install openssl
luarocks install luaposix
luarocks install lua-cjson
mkdir -p -- /srv/board /srv/board/Source /srv/board/Cache /srv/board/Lib /var/log/lighttpd /var/cache/lighttpd/uploads
wget -O /srv/board/Lib/unimathsymbols.txt https://milde.users.sourceforge.net/LUCR/Math/data/unimathsymbols.txt
mount -t tmpfs tmpfs -- /srv/board/Cache
mount -t tmpfs tmpfs -- /var/cache/lighttpd/uploads
printf '\ntmpfs  /srv/board/Cache  tmpfs  rw,auto,nofail,nodev,nosuid,relatime  0  0\ntmpfs  /var/cache/lighttpd/uploads  tmpfs  rw,auto,nofail,nodev,nosuid,relatime  0  0\n' >> /etc/fstab
chown www-data:www-data -- /srv/board
if [ "$source" != "/srv/board/Source" ]; then
  chown "$(stat -c '%u:%g' -- "$source")" -- /srv/board/Source
  sudo -u '#'"$(stat -c '%u' -- "$source")" git clone --no-local "$source" /srv/board/Source
fi
su -s /bin/sh -c /srv/board/Source/setup.sh www-data
chown root:root -- /srv/board
cp /srv/board/Source/lighttpd.conf /etc/lighttpd/lighttpd.conf
cp /srv/board/Source/crontab.txt /etc/cron.d/board
if service lighttpd status >/dev/null 2>/dev/null; then
  service lighttpd restart
fi
