CREATE TABLE captchas (
  challenge TEXT NOT NULL,
  solution  TEXT NOT NULL,
  date      INTEGER
);

CREATE INDEX captchas_by_challenge ON captchas (challenge);
CREATE INDEX captchas_by_solution  ON captchas (solution);
CREATE INDEX captchas_by_date      ON captchas (date);

CREATE TABLE redacted_changes (
  action    INTEGER NOT NULL,
  table_id  INTEGER NOT NULL,
  row_key           NOT NULL,
  column_id TEXT    NOT NULL,
  old_value,
  new_value,
  PRIMARY KEY (action, table_id, row_key, column_id)
);

CREATE TABLE logins (
  moderator TEXT NOT NULL PRIMARY KEY,
  password  TEXT,
  status    INTEGER NOT NULL DEFAULT 0
);

CREATE INDEX logins_by_password ON logins (password);
