-- Migrates a Nanochan 1.0 database to a Nanochan 2.0 database
CREATE INDEX boards_index ON Boards (MaxPostNumber);
CREATE INDEX file_index ON File (Name);
CREATE INDEX filter_index ON Posts (Email, Parent);
CREATE INDEX global_index ON Global (Name);
CREATE INDEX logs_index ON Logs (Date);
CREATE INDEX stats_index ON Posts (Board, Parent, Date);
CREATE INDEX thread_index ON Posts (Board, Number);
CREATE INDEX threads_index ON Posts (Board, Parent, Autosage);
CREATE INDEX recent_index ON Posts (Date, Email, Parent);
CREATE INDEX refs_index ON Refs (Board, Referee);
-- Removing extra \r from post
UPDATE Posts SET Comment = REPLACE(Comment, char(13), '');
-- Remove <br /> before posts
UPDATE Posts SET Comment = SUBSTR(Comment, 7) WHERE Comment LIKE "<br />%";
-- Create new tables
CREATE TABLE Banners (Board TEXT NOT NULL, File TEXT NOT NULL);
CREATE INDEX banners_index ON Banners (Board);
CREATE TABLE Banned (Hash BLOB NOT NULL, Reason TEXT NOT NULL);
CREATE INDEX banned_index ON Banned (Hash);
-- Cleanup
VACUUM;
ANALYZE;
-- After Nanochan 2.0 release
-- Create threads table to speed up overboard / catalog
-- Save filesize in database
