-- announcement
SELECT Value FROM Global WHERE Name = 'announce';
-- banner
SELECT File FROM Banners Where Board = ?;
-- boards
SELECT Name, Title, Subtitle FROM Boards ORDER BY MaxPostNumber DESC;
-- check banned
SELECT 1 FROM Banned WHERE Hash = ?;
-- logs
SELECT Name, Board, Date, Description FROM Logs ORDER BY Date DESC LIMIT 128 OFFSET ?;
-- recent
SELECT p.ROWID, File, ThumbWidth, ThumbHeight FROM (SELECT ROWID, File FROM Posts ORDER BY Date DESC LIMIT ? OFFSET ?) p INNER JOIN File f ON File = f.Name;
SELECT p.ROWID, Referrer FROM (SELECT ROWID, Board, Number FROM Posts ORDER BY Date DESC LIMIT ? OFFSET ?) p INNER JOIN Refs r ON p.Board = r.Board AND Number = Referee;
SELECT ROWID, Board, Number, Parent, Date, Name, Email, Subject, Comment FROM Posts ORDER BY Date DESC LIMIT ? OFFSET ?;
-- recent all
SELECT p.ROWID, File, ThumbWidth, ThumbHeight FROM (SELECT ROWID, File FROM Posts WHERE Email = 'sage' AND File <> '' AND Parent = 0 AND Name <> 'Nanonymous' AND tvolDeleteName <> '' ORDER BY Date DESC LIMIT ? OFFSET ?) p INNER JOIN File f ON File = f.Name;
SELECT p.ROWID, Referrer FROM (SELECT ROWID, Board, Number FROM Posts WHERE Email = 'sage' AND File <> '' AND Parent = 0 AND Name <> 'Nanonymous' AND tvolDeleteName <> '' ORDER BY Date DESC LIMIT ? OFFSET ?) p INNER JOIN Refs r ON p.Board = r.Board AND Number = Referee;
SELECT ROWID, Board, Number, Parent, Date, Name, Email, Subject, Comment FROM Posts WHERE Email = 'sage' AND File <> '' AND Parent = 0 AND Name <> 'Nanonymous' AND tvolDeleteName <> '' ORDER BY Date DESC LIMIT ? OFFSET ?;
-- stats
SELECT b.Name, (SELECT COUNT(*) FROM Posts WHERE Date > CAST(STRFTIME('%s', 'now', '-1 day') AS INTEGER) AND Parent = 0 AND Board = b.Name), (SELECT COUNT(*) FROM Posts WHERE Date > CAST(STRFTIME('%s', 'now', '-7 days') AS INTEGER) AND Parent = 0 AND Board = b.Name), (SELECT COUNT(*) FROM Posts WHERE Date > CAST(STRFTIME('%s', 'now', '-1 hour') AS INTEGER) AND Board = b.Name), (SELECT COUNT(*) FROM Posts WHERE Date > CAST(STRFTIME('%s', 'now', '-1 day') AS INTEGER) AND Board = b.Name), (SELECT COUNT(*) FROM Posts WHERE Date > CAST(STRFTIME('%s', 'now', '-7 days') AS INTEGER) AND Board = b.Name), (SELECT COUNT(*) FROM Posts WHERE Board = b.Name) FROM Boards b ORDER BY MaxPostNumber DESC;
-- thread
SELECT p.ROWID, File, ThumbWidth, ThumbHeight FROM (SELECT ROWID, File FROM Posts WHERE Board = ? AND Parent = ?) p INNER JOIN File f ON File = f.Name;
SELECT p.ROWID, Referrer FROM (SELECT ROWID, Board, Number FROM Posts WHERE Board = ? AND Parent = ?) p INNER JOIN Refs r ON p.Board = r.Board AND Number = Referee;
SELECT ROWID, Board, Number, Parent, Date, Name, Email, Subject, Comment FROM Posts WHERE Board = ? AND Parent = ? ORDER BY Date;
-- threads overboarda
SELECT Parent, COUNT(*) FROM Posts GROUP BY Parent;
SELECT p.ROWID, File, ThumbWidth, ThumbHeight FROM (SELECT ROWID, File FROM Posts WHERE Board = ? AND Parent = 0 ORDER BY LastBumpDate DESC LIMIT 100) p INNER JOIN File f ON File = f.Name;
SELECT ROWID, Board, Number, LastBumpDate, Subject, Comment, Sticky, Lock, Autosage, Cycle FROM Posts WHERE Parent = 0 ORDER BY LastBumpDate DESC LIMIT 100;
-- threads catalog
SELECT Parent, COUNT(*) FROM Posts WHERE Board = ? GROUP BY Parent;
SELECT p.ROWID, File, ThumbWidth, ThumbHeight FROM (SELECT ROWID, File FROM Posts WHERE Board = ? AND Parent = 0 ORDER BY Sticky DESC, LastBumpDate DESC LIMIT 100) p INNER JOIN File f ON File = f.Name;
SELECT ROWID, Board, Number, LastBumpDate, Subject, Comment, Sticky, Lock, Autosage, Cycle FROM Posts WHERE Board = ? AND Parent = 0 ORDER BY Sticky DESC, LastBumpDate DESC LIMIT 100;
-- threads overboard
SELECT Parent, COUNT(*) FROM Posts WHERE Board IN (?, ?, ?, ?, ?, ?) GROUP BY Parent;
SELECT p.ROWID, File, ThumbWidth, ThumbHeight FROM (SELECT ROWID, File FROM Posts WHERE Board IN (?, ?, ?, ?, ?, ?) AND Parent = 0 AND Autosage = 0 ORDER BY LastBumpDate DESC LIMIT 100) p INNER JOIN File f ON File = f.Name;
SELECT ROWID, Board, Number, LastBumpDate, Subject, Comment, Sticky, Lock, Autosage, Cycle FROM Posts WHERE Board IN (?, ?, ?, ?, ?, ?) AND Parent = 0 AND Autosage = 0 ORDER BY LastBumpDate DESC LIMIT 100;