#ifndef NANOCHAN_DATABASE_DATABASE_H
#define NANOCHAN_DATABASE_DATABASE_H

#include <memory>
#include <string_view>

#include "prepared_statement.h"

namespace database {

class Database {
 public:
  virtual ~Database() = default;
  virtual std::unique_ptr<PreparedStatement> prepareStatement(std::string_view sql) = 0;
  virtual void transactionBegin() = 0;
  virtual void transactionEnd() = 0;
  virtual void transactionRollback() = 0;
};

}  // namespace database

#endif  // NANOCHAN_DATABASE_DATABASE_H