#ifndef NANOCHAN_DATABASE_PREPARED_STATEMENT_H
#define NANOCHAN_DATABASE_PREPARED_STATEMENT_H

#include <cstdint>
#include <span>

namespace database {

enum class QueryResult { row, done };

class PreparedStatement {
 public:
  virtual ~PreparedStatement() = default;
  virtual void bind(int column, bool data) = 0;
  virtual void bind(int column, int64_t data) = 0;
  virtual void bind(int column, std::string_view data) = 0;
  virtual std::span<const uint8_t> getBlob(int column) = 0;
  virtual bool getBool(int column) = 0;
  virtual int64_t getInt(int column) = 0;
  virtual std::string getString(int column) = 0;
  virtual QueryResult step() = 0;
};

}  // namespace database

#endif  // NANOCHAN_DATABASE_PREPARED_STATEMENT_H
