#ifndef NANOCHAN_DATABASE_SQLITE_SQLITE_DATABASE_H
#define NANOCHAN_DATABASE_SQLITE_SQLITE_DATABASE_H

#include <sqlite3.h>

#include <string_view>

#include "../database.h"

namespace database {

class SqliteDatabase : public Database {
 private:
  sqlite3* handle;

 public:
  explicit SqliteDatabase(const char* filename);
  ~SqliteDatabase() override;
  SqliteDatabase(const SqliteDatabase& other) = delete;
  SqliteDatabase& operator=(const SqliteDatabase& other) = delete;
  SqliteDatabase(SqliteDatabase&& other) noexcept;
  SqliteDatabase& operator=(SqliteDatabase&& other) noexcept;
  std::unique_ptr<PreparedStatement> prepareStatement(std::string_view sql) override;
  void transactionBegin() override;
  void transactionEnd() override;
  void transactionRollback() override;
};

}  // namespace database

#endif  // NANOCHAN_DATABASE_SQLITE_SQLITE_DATABASE_H