#include "font_config.h"

#include <cassert>
#include <stdexcept>

namespace font {

bool FontConfig::initialized = false;

FontConfig::FontConfig() {
  assert(!initialized);
  handle = FcInitLoadConfigAndFonts();
  if (!handle) {
    throw std::runtime_error("Could not initialize fontconfig");
  }
  initialized = true;
}

FontConfig::~FontConfig() {
  FcConfigDestroy(handle);
  FcFini();
  initialized = false;
}

}  // namespace font