#ifndef NANOCHAN_FONT_FONT_FACE_H
#define NANOCHAN_FONT_FONT_FACE_H

#include "font_glyph.h"

class Freetype {};

namespace font {

class FontFace {
 private:
  FT_Face handle;

 public:
  explicit FontFace(FT_Face face);
  ~FontFace();
  FontFace(const FontFace& other) = delete;
  FontFace& operator=(const FontFace& other) = delete;
  FontFace(FontFace&& other) noexcept;
  FontFace& operator=(FontFace&& other) noexcept;
  void setSize(FT_UInt height);
  FontGlyph rasterize(char c);
};

}  // namespace font

#endif  // NANOCHAN_FONT_FACE_H