#include "font_glyph.h"

#include <utility>

namespace font {

FontGlyph::FontGlyph(FT_BitmapGlyph bitmapGlyph) : handle(bitmapGlyph) {}

FontGlyph::~FontGlyph() { FT_Done_Glyph(reinterpret_cast<FT_Glyph>(handle)); }

FontGlyph::FontGlyph(FontGlyph &&other) noexcept { handle = std::exchange(other.handle, nullptr); }

FontGlyph &FontGlyph::operator=(FontGlyph &&other) noexcept {
  std::swap(handle, other.handle);
  return *this;
}

FT_Bitmap FontGlyph::bitmap() {
  return handle->bitmap;
}

}  // namespace font