#include "font_pattern.h"

#include <stdexcept>

namespace font {

FontPattern::FontPattern(const FontConfig& fontConfig, const NamePattern& namePattern) {
  FcResult result;
  handle = FcFontMatch(fontConfig.handle, namePattern.handle, &result);
  if (!handle) {
    throw std::runtime_error("Could not match font");
  }
}

FontPattern::~FontPattern() { FcPatternDestroy(handle); }

void FontPattern::path(char** out) {
  if (FcPatternGetString(handle, FC_FILE, 0, reinterpret_cast<FcChar8**>(out)) != FcResultMatch) {
    throw std::runtime_error("Could not get font path");
  }
}

}  // namespace font