#ifndef NANOCHAN_FONT_FREETYPE_H
#define NANOCHAN_FONT_FREETYPE_H

#include <ft2build.h>
#include FT_FREETYPE_H

#include <string_view>

#include "font_config.h"
#include "font_face.h"

namespace font {

class Freetype {
 private:
  FontConfig fontConfig;

 public:
  FT_Library handle = nullptr;
  Freetype();
  ~Freetype();
  Freetype(const Freetype& other) = delete;
  Freetype& operator=(const Freetype& other) = delete;
  Freetype(Freetype&& other) noexcept;
  Freetype& operator=(Freetype&& other) noexcept;
  FontFace open(std::basic_string_view<char> name);
};

}  // namespace font

#endif  // NANOCHAN_FONT_FREETYPE_H