#include "name_pattern.h"

#include <stdexcept>

namespace font {

NamePattern::NamePattern(const FontConfig& fontConfig, const std::string_view name) {
  handle = FcNameParse(reinterpret_cast<const FcChar8*>(name.data()));
  if (!handle) {
    throw std::runtime_error("Could not allocate name pattern");
  }
  if (!FcConfigSubstitute(fontConfig.handle, handle, FcMatchPattern)) {
    FcPatternDestroy(handle);
    throw std::runtime_error("Could not execute config substitutions");
  }
  FcDefaultSubstitute(handle);
}

NamePattern::~NamePattern() { FcPatternDestroy(handle); }

}  // namespace font