#ifndef IMAGEBOARD_THUMBNAILER_SYSTEM_H
#define IMAGEBOARD_THUMBNAILER_SYSTEM_H

#include <optional>
#include <string>
#include <string_view>

#include "../util/posix_filesystem.h"
#include "imageboard.h"

namespace imageboard {

class ThumbnailerSystem {
 private:
  const ImageBoard& imageboard;
  util::Filesystem& filesystem;
  std::vector<std::vector<uint8_t>> banned;

 public:
  ThumbnailerSystem(const ImageBoard& imageboard, util::Filesystem& filesystem);
  std::optional<File> saveMedia(std::string_view originalFilename, std::string_view fileContents, bool generateIcon);
};

}  // namespace imageboard

#endif
