#ifndef MEDIA_CODEC_CONTEXT_H
#define MEDIA_CODEC_CONTEXT_H

#include "format_context.h"
#include "frame.h"
#include "packet.h"
extern "C" {
#include <libavcodec/avcodec.h>
}

namespace media {

class CodecContext {
 public:
  explicit CodecContext(const FormatContext& formatContext);
  ~CodecContext();
  CodecContext(const CodecContext& other) = delete;
  CodecContext& operator=(const CodecContext& other) = delete;
  CodecContext(CodecContext&& other) noexcept;
  CodecContext& operator=(CodecContext&& other) noexcept;
  bool sendPacket(const Packet& packet) const;
  bool receiveFrame(const Frame& frame) const;
  bool isVideoPacket(const Packet& packet) const;
  AVCodecContext* context = nullptr;
  int videoStreamIndex;
};

}  // namespace media

#endif
