#ifndef MEDIA_FORMAT_CONTEXT_H
#define MEDIA_FORMAT_CONTEXT_H

#include "frame.h"
#include "io_context.h"
#include "packet.h"
extern "C" {
#include <libavformat/avformat.h>
}
#include <optional>

namespace media {

class FormatContext {
 public:
  FormatContext(const char *filename, IOContext&& ioContext);
  ~FormatContext();
  FormatContext(const FormatContext& other) = delete;
  FormatContext& operator=(const FormatContext& other) = delete;
  FormatContext(FormatContext&& other) noexcept;
  FormatContext& operator=(FormatContext&& other) noexcept;
  bool readFrame(const Packet& packet) const;
  int64_t frameTimestamp(const Packet& packet, const Frame& frame) const;
  AVFormatContext* context = nullptr;
  IOContext ioContext;
};

}  // namespace media

#endif