#include "frame.h"

#include <stdexcept>
#include <utility>

namespace media {

Frame::Frame() {
  handle = av_frame_alloc();
  if (!handle) {
    throw std::runtime_error("Could not allocate frame");
  }
}

Frame::~Frame() { av_frame_free(&handle); }

Frame::Frame(Frame&& other) noexcept { handle = std::exchange(other.handle, nullptr); }

Frame& Frame::operator=(Frame&& other) noexcept {
  std::swap(handle, other.handle);
  return *this;
}

bool Frame::applyCropping() const { return av_frame_apply_cropping(handle, 0) >= 0; }

}  // namespace media
