#ifndef MEDIA_IO_CONTEXT_H
#define MEDIA_IO_CONTEXT_H

extern "C" {
#include <libavformat/avio.h>
}
#include <string_view>

namespace media {

struct SeekBuffer {
  std::string_view buffer;
  size_t offset;
};

class IOContext {
 public:
  explicit IOContext(std::string_view buffer);
  ~IOContext();
  IOContext(const IOContext& other) = delete;
  IOContext& operator=(const IOContext& other) = delete;
  IOContext(IOContext&& other) noexcept;
  IOContext& operator=(IOContext&& other) noexcept;
  AVIOContext* context = nullptr;
  SeekBuffer buffer;
};

}  // namespace media

#endif
