#include "jpeg.h"

#include <turbojpeg.h>
#include <utility>

namespace media {

JPEG::JPEG(uint8_t* imageBuffer, const size_t imageSize, const int width, const int height)
    : buffer(imageBuffer, imageSize), width(width), height(height) {}

JPEG::~JPEG() { tjFree(buffer.data()); }

JPEG::JPEG(JPEG&& other) noexcept {
  buffer = std::exchange(other.buffer, {});
  width = other.width;
  height = other.height;
}

JPEG& JPEG::operator=(JPEG&& other) noexcept {
  std::swap(buffer, other.buffer);
  width = other.width;
  height = other.height;
  return *this;
}

}  // namespace media
