#ifndef MEDIA_JPEG_H
#define MEDIA_JPEG_H

#include <cstdint>
#include <span>

namespace media {

class JPEG {
 public:
  JPEG(uint8_t* imageBuffer, size_t imageSize, int width, int height);
  ~JPEG();
  JPEG(const JPEG& other) = delete;
  JPEG& operator=(const JPEG& other) = delete;
  JPEG(JPEG&& other) noexcept;
  JPEG& operator=(JPEG&& other) noexcept;
  std::span<uint8_t> buffer;
  int width;
  int height;
};

}  // namespace media

#endif
