#ifndef MEDIA_JPEG_COMPRESSOR_H
#define MEDIA_JPEG_COMPRESSOR_H

#include <turbojpeg.h>

#include "jpeg.h"

namespace media {

class JPEGCompressor {
 private:
  tjhandle handle = nullptr;

 public:
  JPEGCompressor();
  ~JPEGCompressor();
  JPEGCompressor(const JPEGCompressor& other) = delete;
  JPEGCompressor& operator=(const JPEGCompressor& other) = delete;
  JPEGCompressor(JPEGCompressor&& other) noexcept;
  JPEGCompressor& operator=(JPEGCompressor&& other) noexcept;
  JPEG compress(const unsigned char* data, int width, int stride, int height, int quality) const;
  JPEG compress(const unsigned char* data, int width, int stride, int height, int quality, bool grayscale) const;
};

}  // namespace media

#endif
