#include "packet.h"

#include <stdexcept>
#include <utility>

namespace media {

Packet::Packet() {
  handle = av_packet_alloc();
  if (!handle) {
    throw std::runtime_error("Could not allocate packet");
  }
}

Packet::~Packet() { av_packet_free(&handle); }

Packet::Packet(Packet&& other) noexcept {
  handle = std::exchange(other.handle, nullptr);
}

Packet& Packet::operator=(Packet&& other) noexcept {
  std::swap(handle, other.handle);
  return *this;
}

}  // namespace media
