#ifndef MEDIA_PDF_THUMBNAILER_H
#define MEDIA_PDF_THUMBNAILER_H

#include <poppler/cpp/poppler-page-renderer.h>
#include <poppler/cpp/poppler-page.h>

#include "thumbnailer.h"

namespace media {

class PDFThumbnailer : public Thumbnailer {
 private:
  poppler::document *document;
  poppler::page *page;
  poppler::page_renderer renderer;

 public:
  explicit PDFThumbnailer(std::string_view contents);
  ~PDFThumbnailer() override;
  PDFThumbnailer(const PDFThumbnailer& other) = delete;
  PDFThumbnailer& operator=(const PDFThumbnailer& other) = delete;
  PDFThumbnailer(PDFThumbnailer&& other) noexcept = delete;
  PDFThumbnailer& operator=(PDFThumbnailer&& other) noexcept = delete;
  std::optional<JPEG> scale(int maxWidth, int maxHeight) override;
  std::vector<uint8_t> dhash() override;
};

}  // namespace media

#endif
