#ifndef MEDIA_THUMBNAILER_FACTORY_H
#define MEDIA_THUMBNAILER_FACTORY_H

#include <memory>

#include "thumbnailer.h"

namespace media {

class ThumbnailerFactory {
 public:
  virtual ~ThumbnailerFactory() = default;
  virtual bool hasThumbnail(std::string_view extension);
  virtual std::unique_ptr<Thumbnailer> create(const std::string& filename, std::string_view contents);
};

}  // namespace media

#endif