#ifndef NANOCHAN_404_H
#define NANOCHAN_404_H

#include <string>
#include <vector>

#include "../imageboard/imageboard.h"

namespace nanochan {

/**
 * @brief 404 page template
 */
class _404 {
 private:
  /**
   * @brief A list of boards
   */
  const std::vector<imageboard::Board>& boards;

 public:
  /**
   * @brief Constructs the template
   *
   * @param boards The boards to use
   */
  _404(const std::vector<imageboard::Board>& boards) : boards(boards){};
  /**
   * @brief Renders the template
   *
   * @return The rendered template
   */
  std::string render();
};

}  // namespace nanochan

#endif
