#ifndef NANOCHAN_500_H
#define NANOCHAN_500_H

#include <string>

namespace nanochan {

/**
 * @brief 500 page template
 */
class _500 {
 private:
  /**
   * @brief The reason the server had an error
   */
  const std::string_view reason;

 public:
  /**
   * @brief Constructs the template
   *
   * @param reason The reason the server had an error
   */
  _500(const std::string_view reason) : reason(reason){};
  /**
   * @brief Renders the template
   *
   * @return The rendered template
   */
  std::string render();
};

}  // namespace nanochan

#endif
