#ifndef NANOCHAN_INDEX_H
#define NANOCHAN_INDEX_H

#include <string>
#include <vector>

#include "../imageboard/imageboard.h"

namespace nanochan {

/**
 * @brief Index page template
 */
class Index {
 private:
  /**
   * @brief Site wide announcement
   */
  const std::string_view announcement;
  /**
   * @brief A list of boards
   */
  const std::vector<imageboard::Board>& boards;

 public:
  /**
   * @brief Constructs the template
   *
   * @param announcement The announcement to use
   * @param boards The boards to use
   */
  Index(const std::string_view announcement, const std::vector<imageboard::Board>& boards)
      : announcement(announcement), boards(boards){};
  /**
   * @brief Renders the template
   *
   * @return The rendered template
   */
  std::string render();
};

}  // namespace nanochan

#endif
