#ifndef NANOCHAN_REDIRECT_H
#define NANOCHAN_REDIRECT_H

#include <string>
#include <vector>

#include "../imageboard/imageboard.h"

namespace nanochan {

/**
 * @brief Redirect page template
 */
class Redirect {
 private:
  /**
   * @brief The url to redirect to
   */
  const std::string_view url;

 public:
  /**
   * @brief Constructs the template
   *
   * @param url The url to redirect to
   */
  Redirect(const std::string_view url) : url(url){};
  /**
   * @brief Renders the template
   *
   * @return The rendered template
   */
  std::string render();
};

}  // namespace nanochan

#endif
