#ifndef NANOCHAN_STATS_H
#define NANOCHAN_STATS_H

#include <string>
#include <vector>

#include "../imageboard/imageboard.h"

namespace nanochan {

/**
 * @brief Stats page template
 */
class Stats {
 private:
  /**
   * @brief A list of boards
   */
  const std::vector<imageboard::Board>& boards;
  /**
   * @brief A list of stats
   */
  const std::vector<imageboard::StatsEntry>& entries;

 public:
  /**
   * @brief Constructs the template
   *
   * @param boards The boards to use
   * @param entries The entries to use
   */
  Stats(const std::vector<imageboard::Board>& boards, const std::vector<imageboard::StatsEntry>& entries)
      : boards(boards), entries(entries){};
  /**
   * @brief Renders the template
   *
   * @return The rendered template
   */
  std::string render();
};

}  // namespace nanochan

#endif
