#ifndef SCGI_HANDLER_H
#define SCGI_HANDLER_H

#include "request.h"

namespace scgi {

/**
 * @brief Interface for handling SCGI requests
 */
class Handler {
 public:
  virtual ~Handler() = default;
  /**
   * @brief Updates various data needed by the handler
   */
  virtual void update() = 0;
  /**
   * @brief This function should handle a SCGI request and produce a response
   *
   * @param request A SCGI request
   * @return A reponse
   */
  virtual std::string handle(const Request& request) = 0;
};

}  // namespace scgi
#endif
