#include <iostream>

#include "compiler.h"

/**
 * Templating: A template compiler that outputs generated cpp code.
 *
 * Templating generates a render function for an existing class
 * with a prototype of std::string render()
 *
 * header The header file of the exiting class
 * namespace The name of the namespace of the existing class
 * class The name of the existing class
 * in The input template
 * out The output source file
 */
int main(int argc, char **argv) {
  if (argc != 6) {
    std::cerr << "templating <header> <namespace> <class> <in> <out>"
              << std::endl;
    return 1;
  }
  return !templating::Compiler::compile(argv[1], argv[2], argv[3], argv[4],
                                        argv[5]);
}
