#include "fake_filesystem.h"

namespace util {

std::optional<std::string> FakeFilesystem::readFile(const std::string& path) {
  auto file = filesystem.find(path);
  if (file == filesystem.cend()) {
    return std::nullopt;
  }
  return file->second;
}

bool FakeFilesystem::writeFile(const std::string& path, const std::string_view contents) {
  filesystem.emplace(path, contents);
  return true;
}

void FakeFilesystem::reset() {
  filesystem.clear();
}

}  // namespace util