#ifndef NANOCHAN_UTIL_FAKE_FILESYSTEM_H
#define NANOCHAN_UTIL_FAKE_FILESYSTEM_H

#include <absl/container/flat_hash_map.h>

#include <optional>
#include <string>
#include <string_view>

#include "filesystem.h"

namespace util {
class FakeFilesystem : public Filesystem {
 private:
  absl::flat_hash_map<std::string, std::string> filesystem;

 public:
  std::optional<std::string> readFile(const std::string& path) override;
  bool writeFile(const std::string& path, std::string_view contents) override;
  void reset();
};

}  // namespace util

#endif