#ifndef NANOCHAN_UTIL_FILESYSTEM_H
#define NANOCHAN_UTIL_FILESYSTEM_H

#include <optional>
#include <string>
#include <string_view>

namespace util {

class Filesystem {
 public:
  virtual ~Filesystem() = default;
  /**
   * @brief Reads a file into string
   *
   * @param path File to readFile
   * @return The file's contents
   */
  virtual std::optional<std::string> readFile(const std::string& path) = 0;
  /**
   * @brief Writes a string to a file
   *
   * @param path The file to write to
   * @param contents The string to write
   * @retval true On success
   * @retval false On failure
   */
  virtual bool writeFile(const std::string& path, std::string_view contents) = 0;
};

}  // namespace util

#endif